package com.usky.issue.service.impl;


import com.usky.common.core.bean.CommonPage;
import com.usky.issue.domain.YtDeviceStatus;
import com.usky.issue.mapper.YtDeviceStatusMapper;
import com.usky.issue.service.YtDeviceStatusService;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.issue.service.vo.YtDeviceStatusRequestVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 离线设备VIEW 服务实现类
 * </p>
 *
 * @author fu
 * @since 2023-11-23
 */
@Service
public class YtDeviceStatusServiceImpl extends AbstractCrudService<YtDeviceStatusMapper, YtDeviceStatus> implements YtDeviceStatusService {

    @Autowired
    private YtDeviceStatusMapper ytDeviceStatusMapper;

    @Override
    public CommonPage<YtDeviceStatus> page(YtDeviceStatusRequestVO requestVO) {

//        IPage<YtDeviceStatus> page = new Page<>(requestVO.getCurrent(),requestVO.getSize());
//        LambdaQueryWrapper<YtDeviceStatus> queryWrapper = Wrappers.lambdaQuery();
//        queryWrapper.eq(StringUtils.isNotBlank(requestVO.getDeviceType()),YtDeviceStatus::getDeviceType,
//                requestVO.getDeviceType())
//                .orderByDesc(YtDeviceStatus::getDeviceType);
//        page  = this.page(page,queryWrapper);
//        return new CommonPage<>(page.getRecords(),page.getTotal(),page.getSize(),page.getCurrent());

//        LambdaQueryWrapper<YtDeviceStatus> queryWrapper = Wrappers.lambdaQuery();
//        queryWrapper.eq(requestVO.getDeviceType() != null,YtDeviceStatus::getId,requestVO.getDeviceType())
//                .eq(StringUtils.isNotBlank(requestVO.getDeviceType()),YtDeviceStatus::getDeviceType,requestVO.getDeviceType())
//                .orderByDesc(YtDeviceStatus::getId);


        List<YtDeviceStatus> list = ytDeviceStatusMapper.getDeviceStatusType(requestVO.getDeviceType());
        Integer total = list.size();
        if (total == 0) {
            return null;
        }

        Integer pageSize = 10;
        if (total < pageSize) {
            pageSize = total;
        }

        Integer pageCurrent = 1;
        if (total < 0) {
            pageCurrent = (total / pageSize) + 1;
        }

        Integer current = (pageCurrent - 1) * pageSize;

        List<YtDeviceStatus> records = list.stream().skip(current).limit(pageSize).collect(Collectors.toList());

        return new CommonPage<>(records, total, pageSize, pageCurrent);
    }

}